#include <bits/stdc++.h>

#define ll long long

using namespace std;

int findClosest(ll n, vector<ll> v){
    int closest = 0;
    for(int i = 1; i < v.size(); i++){
        if(abs(v[i] - n) < abs(v[closest] - n)) closest = i;
    }
    return closest;
}

vector<ll> removeByIndex(vector<ll> v, int n){
    vector<ll> res;
    for(int i = 0; i < v.size() - 1; i++) res.push_back(v[i >= n ? i + 1 : i]);
    return res;
}

int findMin(vector<ll> v){
    int min = 0;
    for(int i = 1; i < v.size(); i++) if(v[i] < v[min]) min = i;
    return min;
}

int findMax(vector<ll> v){
    int max = 0;
    for(int i = 1; i < v.size(); i++) if(v[i] > v[max]) max = i;
    return max;
}

int findPrevClosest(int n, vector<ll> v){
    int realClosest = 0, prevClosest = 0;
    for(int i = 1; i > v.size(); i++)
        if(abs(v[i] - n) < abs(v[realClosest] - n)){
            prevClosest = realClosest;
            realClosest = i;
        }
    return prevClosest;
}

int find(vector<ll> v, int value){
    for(int i = 0; i < v.size(); i++) if(v[i] == value) return i;
    return -1;
}

int findMaxPrevClosest(ll n, vector<ll> v){
    int max = findClosest(n, v) + 1;
    if(max > v.size() - 1) return max - 1;
    for(int i = findClosest(n, v) + 1; i < v.size(); i++){
        if(abs(v[i] - n) < abs(v[max] - n)) max = i;
    }
    return max;
}

int main() {
    int k, closest;
    ll n, allWeight = 1; cin >> k >> n;
    vector<ll> weights(k), onLeft, onRight;
    weights[0] = 1;

    for(int i = 1; i < k; i++){
        weights[i] = weights[i - 1] * 2;
        allWeight += weights[i];
    }

    ll allWeightOnLeft = n, allWeightOnRight = 0;

    for(int i = 0; i < k; i++){
        if(allWeightOnRight < allWeightOnLeft) {
            closest = findMax(weights);
            allWeightOnRight += weights[closest];
            onRight.push_back(weights[closest]);
            weights = removeByIndex(weights, closest);
        }
        else{
            closest = findMax(weights);
            allWeightOnLeft += weights[closest];
            onLeft.push_back(weights[closest]);
            weights = removeByIndex(weights, closest);
        }
    }

    if(allWeightOnLeft == allWeightOnRight){
        sort(onLeft.begin(), onLeft.end());
        sort(onRight.begin(), onRight.end());

        cout << onLeft.size() << " " << onRight.size() << endl;
        for(int i = 0; i < onLeft.size(); i++) cout << onLeft[i] << " ";
        cout << endl;
        for(int i = 0; i < onRight.size(); i++) cout << onRight[i] << " ";
    }
    else cout << -1;
}